From 439ed0b91a129a2980072855b9534a9303e5fbd1 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Dec 13 2020 01:01:06 +0000
Subject: [PATCH 1717/2232] Remove unneeded self check in Box<T>::operator=


As long as T's operator= correctly handles self assignment, this logic
is correct without the additional check.

---

diff --git a/include/cxx.h b/include/cxx.h
index 0a9df91..ab03f32 100644
--- a/include/cxx.h
+++ b/include/cxx.h
@@ -597,15 +597,13 @@ Box<T>::~Box() noexcept {
 
 template <typename T>
 Box<T> &Box<T>::operator=(const Box &other) {
-  if (this != &other) {
-    if (this->ptr) {
-      **this = *other;
-    } else {
-      allocation alloc;
-      ::new (alloc.ptr) T(*other);
-      this->ptr = alloc.ptr;
-      alloc.ptr = nullptr;
-    }
+  if (this->ptr) {
+    **this = *other;
+  } else {
+    allocation alloc;
+    ::new (alloc.ptr) T(*other);
+    this->ptr = alloc.ptr;
+    alloc.ptr = nullptr;
   }
   return *this;
 }

